﻿using System.IO;
using System.Threading.Tasks;
using System.Windows.Forms;
using NTERA.Console;
using NTERA.Game.EraEmu;
using NTERA.Interop;

namespace NTERA
{
	public partial class formMain : Form
	{
		private GameInstance instance = new GameInstance();

		public formMain()
		{
			InitializeComponent();

			NTERA.Interop.Program.CMain(Directory.GetCurrentDirectory() + "\\");


			Task.Factory.StartNew(() => instance.Run(new EraConsoleInstance(consoleControl1.Renderer), new EmuEraGameInstance()));
		}

		private void txtInput_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Enter)
			{
				instance.GiveInput(txtInput.Text);
				txtInput.Text = "";

				e.Handled = true;
				e.SuppressKeyPress = true;
			}
		}
	}
}
